import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsProduct, CmsProductParam } from './model';


/**
 * 分页查询产品
 */
export async function pageCmsProduct(params: CmsProductParam) {
  const res = await request.get<ApiResult<PageResult<CmsProduct>>>(
    '/cms/cms-product/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询产品列表
 */
export async function listCmsProduct(params?: CmsProductParam) {
  const res = await request.get<ApiResult<CmsProduct[]>>(
    '/cms/cms-product',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加产品
 */
export async function addCmsProduct(data: CmsProduct) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-product',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改产品
 */
export async function updateCmsProduct(data: CmsProduct) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-product',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除产品
 */
export async function removeCmsProduct(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-product/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除产品
 */
export async function removeBatchCmsProduct(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-product/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询产品
 */
export async function getCmsProduct(id: number) {
  const res = await request.get<ApiResult<CmsProduct>>(
    '/cms/cms-product/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

export async function getCount(params: CmsProductParam) {
  const res = await request.get('/cms/cms-product/data', {
    params
  });
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
